/* fichero listord.c */
/* Comprobar si un nmero est en un vector ordenado,
   y si no est, incluirlo */
#include <stdio.h>
#include <stdlib.h>

void main(void) {
   int i, j, n, num, temp, vector[100];
   
   printf("Teclea el numero de elementos: ");
   scanf("%d", &n);
   
   /* lectura de los elementos del vector */
   for (i=0; i<n; i++) {
       printf("vector[%d]: ", i+1);
       scanf("%d", &vector[i]);
   }
   
   /* ordenacin de menor a mayor */
   for (i=0; i<n-1; i++)
      for (j=i+1; j<n; j++)
         if (vector[i]>vector[j]) {
            temp=vector[i];
            vector[i]=vector[j];
            vector[j]=temp;
         }
         
   /* Escritura del vector ordenado */
   printf("\n\nEl vector ordenado es:\n");
   for (i=0; i<n; i++)
       printf("%6d", vector[i]);

   printf("\n\nTeclea el numero deseado: ");
   scanf("%d", &num);
   /* Comprobar si est en la lista. Bsqueda binaria */
   if (num<vector[0]) {             /* est antes del primero */
       i=0;
       j=1;
   } else if (num>vector[n-1]) {    /* est despus del ltimo */
       i=n-2;
       j=n-1;
   } else {   
       i=0;
       j=n-1;
       while (j>i+1) {
           temp=(j+i)/2;
           if (num==vector[temp]) {
               printf("\n\nEl numero %d pertenece al vector, en posicion %d.", 
                      num, temp+1);
               printf("\n");
               exit(0);
           }
           else if (num<vector[temp]) 
               j=temp;
           else
               i=temp;
       } /* fin bucle while */
   
       if (num==vector[i]) {
           printf("\n\nEl numero %d pertenece al vector, en posicion %d.", 
               num, i+1);
           printf("\n");
           exit(0);
       } else if (num==vector[j]) {
           printf("\n\nEl numero %d pertenece al vector, en posicion %d.", 
               num, j+1);
           printf("\n");
           exit(0);
       }
   }
   /* Insertar num en vector[] */
   if (num<vector[i]) {               /* se inserta delante de i */
      for (j=n-1; j>=i; j--)
         vector[j+1]=vector[j];
      vector[i]=num;
   } else if (num<vector[j]) {
      for (j=n-1; j>i; j--)           /* se inserta detrs de i */
         vector[j+1]=vector[j];
      vector[i+1]=num;
   } else                             /* se inserta detrs de j */
      vector[j+1]=num;
   n++;
   /* Escritura del nuevo vector ordenado */
   printf("\n\nEl nuevo vector ordenado es:\n");
   for (i=0; i<n; i++)
      printf("%6d", vector[i]);
   printf("\n");
} /* fin de main() */
