/* fichero rotamat.c */
/* girar una matriz rectangular */
#include<stdio.h>
#include<stdlib.h>
double **crearMatriz(int, int);

void main(void) {
    int numfil, numcol;
    int i, j, num, giro;
    double **a;

    printf("Introduce el numero de filas: ");
    scanf("%d", &numfil);
    printf("Introduce el numero de columnas: "); 
    scanf("%d", &numcol);
    a=crearMatriz(numfil, numcol);
    for (i=0; i<numfil; i++)
        for(j=0; j<numcol; j++) {
            printf("Elemento (%d,%d):  ", i+1, j+1);
            scanf("%lf", &a[i][j]);
        }
    printf("\nLa matriz original es: ");
    for (i=0; i<numfil; i++) {
        printf("\n");
        for (j=0; j<numcol; j++)
            printf("%12.4lf  ", a[i][j]);
    }
    printf("\n\nCuantas veces deseas girar la matriz?: ");
    scanf("%d", &num);
    giro=num%4;
    if (giro==1) {
        printf("\nLa matriz girada %d veces es:", num);
        for (j=numcol-1; j>=0; j--) {
            printf("\n");
            for(i=0; i<numfil; i++)
                printf("%12.4lf  ", a[i][j]);
        }
    } else if(giro==2) {
        printf("\nLa matriz girada %d veces es:", num);
        for (i=numfil-1; i>=0; i--) {
            printf("\n");
            for (j=numcol-1; j>=0; j--)
                printf("%12.4lf  ", a[i][j]);
        }
    } else if(giro==3) {
        printf("\nLa matriz girada %d veces es:",num);
        for (i=numcol-1; i>=0; i--) {
            printf("\n");
            for (j=numfil-1; j>=0; j--)
                printf("%12.4lf  ", a[j][i]);
        }    
    } else { 
        printf("\nLa matriz girada %d veces es:", num);
        for(i=0; i<numfil; i++) {
            printf("\n");
            for (j=0; j<numcol; j++)
                printf("%12.4lf  ", a[i][j]);
        }
    }
    printf("\n");
}

double **crearMatriz(int m, int n) {
    double **matriz;
    int i;
    matriz=calloc(m, sizeof(double *));
    matriz[0]=calloc(m*n, sizeof(double));
    for(i=0; i<m; i++)
        matriz[i]=matriz[0]+n*i;
    return matriz;
}
