/* fichero cambio.c */
#include<stdio.h>
#include<stdlib.h>

void main(void) {
    int m, n, p, q;
    int i, j, k, l;
    double **a, **b;
    double **crearMatriz(int, int);
    
    printf("Numero de filas y de columnas de la matriz: ");
    scanf("%d%d", &m, &n);
    a=crearMatriz(m,n);

    printf("\nIntroduce los elementos de la matriz.\n");
    for (i=0; i<m; i++)
        for(j=0; j<n; j++){
            printf("Elemento (%d,%d): ", i+1, j+1);
            scanf("%lf", &a[i][j]);
        }
    do {
        printf("\nNumero de filas y columnas de la nueva matriz: ");
        scanf("%d%d", &p, &q);
    } while(p*q != m*n);

    b=crearMatriz(p, q);
    for (i=0, k=0; i<m; i++)
        for (j=0, l=0; j<n; j++){
            k=(i*n+j)/q;
            l=(i*n+j)-k*q;
            b[k][l]=a[i][j];
        }
    for (i=0; i<p; i++){
        printf("\n");
        for (j=0; j<q; j++)
            printf("%5.1lf", b[i][j]);
    }
    printf("\n");
}

double **crearMatriz(int m, int n) {
    double **matriz;
    int i;
    matriz=calloc(m, sizeof(double *));
    matriz[0]=calloc(m*n, sizeof(double));
    for(i=0; i<m; i++)
        matriz[i]=matriz[0]+n*i;
    return matriz;
}
