/* fichero elecciones.c*/
/* Calculo de escaos por partido (d'Hondt). */

#include <stdio.h>
#define    NESC    2           /* nmero de escaos en liza. */
#define    NPAR    3           /* nmero de partidos que concurren */
void main(void) {
    int  i, esca;
    int  nEsca[NPAR];     /* nEsca{[NPAR]= n de escaos por partido*/
    long nVotos[NPAR];    /* nVotos[NPAR]=n de votos por partido*/
    int  nextEsc(long *, int *);   /* declaracin de funcin */
    
    for(i=0; i<NPAR; ++i)
        nEsca[i]=0;

    printf("Teclea el numero de votos de cada partido.\n");
    for (i=0; i<NPAR; ++i) {
        printf("\nPartido %d: ", i+1);
        scanf("%ld", &nVotos[i]);
    }
    
    for(i=0; i<NESC; ++i) {           /* asignacin de escaos */
        esca = nextEsc(nVotos, nEsca);
        nEsca[esca] = nEsca[esca]+1;
    }

    for (i=0; i<NPAR; ++i) 
        printf("\nEl partido %d ha obtenido %d escagnos.", 
            i+1, nEsca[i]);
    printf("\n");
}

int nextEsc( long nVotos[], int nEsca[]) {
    int  imaximo=0, i;
    long maximo=0;

    for( i=0; i<NPAR; ++i) {
        if( maximo<(nVotos[i]/(nEsca[i]+1)) ) {
            maximo=nVotos[i]/(nEsca[i]+1);
            imaximo=i;
        }
    }
    return imaximo;
}
