/* fichero derivada.c */
/* clculo numrico de la derivada de una funcin en un punto */
#include<stdio.h>
#include<math.h>
#define SIZE 101

void main(void) {
    int i;
    double h=0.01;
    double x[SIZE], f[SIZE], d[SIZE], e[SIZE];

    x[0]=0.0;
    for (i=1; i<SIZE; i++)
        x[i]=i*h;
    for (i=0; i<SIZE; i++)
        f[i]=sin(x[i]);                /* funcin seno(x) */
    d[0]=(f[1]-f[0])/h;
    for (i=1; i<SIZE-1; i++)
        d[i]=(f[i+1]-f[i-1])/(2*h);    /* derivada numrica */
    d[SIZE-1]=(f[SIZE-1]-f[SIZE-2])/h;  
    for (i=0; i<SIZE; i++)
        e[i]=cos(x[i]);                /* derivada exacta */
    printf("           x           seno(x)       deriv. num.   deriv. exacta\n");
    for (i=0; i<SIZE; i++) 
        printf("%15.8lf %15.8lf %15.8lf %15.8lf\n",x[i], f[i], d[i], e[i]);
}
