/* fichero calcula.c */
/* calculadora elemental interactiva */
#include <stdio.h>
#include <stdlib.h>

void main(void) {
    int fin=1; 
    double a, b;
    char c;
    double suma(double, double);
    double resta(double, double);
    double multiplicacion(double, double);
    double division(double, double);
    void valor(double *, double *);
    void menu(void);

    do {
        menu();
        c=getchar();
        if (c!='\n' && (c<'1'||c>'5')) { 
            printf("%s%s", "\nNo es una opcion valida", 
                " introduce de nuevo el numero");
            printf("\nPulsa una tecla y repite el proceso");
            getchar();
            getchar();
        }
        switch(c) {
            case '1':
                valor(&a, &b);
                suma(a, b);
                break;
            case '2':
                valor(&a, &b);
                resta(a, b);
                break;
            case '3':
                valor(&a, &b);
                multiplicacion(a, b);
                break;
            case '4':
                valor(&a, &b);
                division(a, b);
                break;
            case '5':
                fin=0;
                break;
        }
    } while(fin);
}

void menu(void) {
    system("cls");
    printf("\n\n\n\tBienvenido al programa matematico.\n");
    printf("\tIntroduce una de las siguientes opciones:");
    printf("\n\n\t\t1.- Sumar numeros");
    printf("\n\n\t\t2.- Restar numeros");
    printf("\n\n\t\t3.- Multiplicar numeros");
    printf("\n\n\t\t4.- Dividir numeros");
    printf("\n\n\t\t5.- Salir\n\n");
}

double suma(double a, double b) {
    printf ("\n\nLa suma introducida es la siguiente:\n");
    printf ("%.2lf + %.2lf = %.2lf", a, b, (a+b));
    getchar();
    getchar();
    return (a+b);
}

double resta(double a, double b) {
    printf ("\n\nLa resta introducida es la siguiente:\n");
    printf ("%.2lf - %.2lf = %.2lf", a, b, (a-b));
    getchar();
    getchar();
    return (a-b);
}

double multiplicacion (double a, double b) {
    printf ("\n\nLa multiplicacion introducida es la siguiente:\n");
    printf ("%.2lf * %.2lf = %.2lf", a, b, (a*b));
    getchar();
    getchar();
    return (a*b);
}

double division(double a, double b) {
    printf ("\n\nLa division introducida es la siguiente:\n");
    printf ("%.2lf / %.2lf = %.2lf", a, b, (a/b));
    getchar();
    getchar();
    return (a/b);
}

void valor(double *a, double*b) {
    system ("cls");
    printf("Introduce el valor del primer termino: ");
    scanf("%lf", a);
    printf("Introduce el valor del segundo termino: ");
    scanf("%lf", b);
}
